% fapte din enunț sau alte fapte necesare modelării constrângerilor
%% când minte fiecare
lies(leo, mon). lies(leo, tue). lies(leo, wed).
lies(uni, thu). lies(uni, fri). lies(uni, sat).

%% noțiunea de ieri
yesterday(Yesterday, Today) :- append(_, [Yesterday, Today | _], [sun, mon, tue, wed, thu, fri, sat, sun]).

%% faptul că un animal spune "Ieri mințeam" 
%% aici trebuie să ne folosim și propria logică: 
%% - pentru ca această afirmație să fie consistentă, este posibil ca animalul
%%   să spună adevărul azi? în ce condiții? dar să mintă? în ce condiții?
speaks(Animal, Today) :- 
	yesterday(Yesterday, Today),
	( lies(Animal, Today), \+lies(Animal, Yesterday) ;
	  \+lies(Animal, Today), lies(Animal, Yesterday)).  

% partea de filtrare
%% pornim cu întreg setul de candidați (toate zilele săptămânii) și păstrăm 
%% candidații care sunt consistenți cu ce a spus leul: Ieri mințeam
candidate1(Today) :- speaks(leo, Today).

%% dintre cei de la pasul anterior,
%% candidații care sunt consistenți cu ce a spus unicornul: Și eu
candidate2(Today) :- candidate1(Today), speaks(uni, Today).
	
	
	

